<?php

add_action('init','of_options');

if (!function_exists('of_options'))
{
	function of_options()
	{
		

		/*-----------------------------------------------------------------------------------*/
		/* TO DO: Add options/functions that use these */
		/*-----------------------------------------------------------------------------------*/
		
		//More Options
		$uploads_arr 		= wp_upload_dir();
		$all_uploads_path 	= $uploads_arr['path'];
		$all_uploads 		= get_option('of_uploads');
		$other_entries 		= array("Select a number:","1","2","3","4","5","6","7","8","9","10","11","12","13","14","15","16","17","18","19");
		$body_repeat 		= array("no-repeat","repeat-x","repeat-y","repeat");
		$body_pos 			= array("top left","top center","top right","center left","center center","center right","bottom left","bottom center","bottom right");
		
		// Image Alignment radio box
		$of_options_thumb_align = array("alignleft" => "Left","alignright" => "Right","aligncenter" => "Center"); 
		
		// Image Links to Options
		$of_options_image_link_to = array("image" => "The Image","post" => "The Post"); 


		/*-----------------------------------------------------------------------------------*/
		/* The Options Array */
		/*-----------------------------------------------------------------------------------*/
		
		//General
		$number_10 = array('Select',1,2,3,4,5,6,7,8,9,10);
		$number_15 = array('Select',1,2,3,4,5,6,7,8,9,10,11,12,13,14,15);
		$number_20 = array('Select',1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20);
		
		//Style Layout
		$style_layout[0] = ADMIN_DIR ."assets/style-wide.png";
		$style_layout[1] = ADMIN_DIR ."assets/style-narrow.png";
		
		//Style Skins
		$style_skins_url = SLICETHEME_BASE_URL .'/css/skins/thumb/';
		$style_skins_path = SLICETHEME_BASE .'/css/skins/';
		$style_skins = array();
		if ( is_dir($style_skins_path) ) {
			if ($style_skins_dir = opendir($style_skins_path) ) { 
				while ( ($style_skins_file = readdir($style_skins_dir)) !== false ) {
					if ( stristr($style_skins_file, ".css") !== false ) {
						$style_skins[$style_skins_file] = $style_skins_url . str_replace("css", "png", $style_skins_file);
					}
				}    
			}
		}
		ksort($style_skins);
		
		//Style Pattern
		$style_pattern_url = SLICETHEME_BASE_URL .'/images/pattern/';
		$style_pattern_path = SLICETHEME_BASE .'/images/pattern/';
		$style_pattern = array();
		//$style_pattern[''] = $style_pattern_url . 'none.png';
		if ( is_dir($style_pattern_path) ) {
			if ($style_pattern_dir = opendir($style_pattern_path) ) { 
				while ( ($style_pattern_file = readdir($style_pattern_dir)) !== false ) {
					if ( stristr($style_pattern_file, ".png") !== false || stristr($style_pattern_file, ".jpg") !== false ) {
							$style_pattern[$style_pattern_file] = $style_pattern_url . $style_pattern_file;
					}
				}    
			}
		}
		ksort($style_pattern);
		
		$get_sidebar = st_option('sidebar');
		$sidebar = array();
		$sidebar['General'] = 'General';
		if ( is_array($get_sidebar) ) {
			foreach ( $get_sidebar as $side ) {
				$sidebar[$side] = $side;
			}
		}
		
		global $style_bg_repeat, $style_bg_attachment, $style_bg_position, $style_font_standar, $style_font_google;
		$style_bg_repeat = array(
			"repeat" => "Repeat All",
			"no-repeat" => "No-Repeat",
			"repeat-x" => "Repeat-X",
			"repeat-y" => "Repeat-Y");
		$style_bg_attachment = array(
			"fixed" => "Fixed",
			"scroll" => "Scroll",
			"inherit" => "Inherit");
		$style_bg_position = array(
			"top left" => "Top Left",
			"top center" => "Top Center",
			"top right" => "Top Right",
			"center left" => "Middle Left",
			"center center" => "Middle Center",
			"center right" => "Middle Right",
			"bottom left" => "Bottom Left",
			"bottom center" => "Bottom Center",
			"bottom right" => "Bottom Right");
		$style_font_standar = array(
			"Arial" => "Arial",
			"Comic Sans MS" => "Comic Sans MS",
			"FreeSans" => "FreeSans",
			"Georgia" => "Georgia",
			"Lucida Sans Unicode" => "Lucida Sans Unicode",
			"Palatino Linotype" => "Palatino Linotype",
			"Symbol" => "Symbol",
			"Tahoma" => "Tahoma",
			"Trebuchet MS" => "Trebuchet MS",
			"Verdana" => "Verdana");
		$json = file_get_contents(ADMIN_PATH.'webfonts.json');
		$webfonts = json_decode($json, true);
		$style_font_google = array();
		foreach ($webfonts['items'] as $item) {
			$family = str_replace(' ', '+', $item['family']);
			$style_font_google[$family] = $item['family'];
		}
		
		
		// Set the Options Array
		global $of_options;
		$of_options = array();
		
		
		//General Settings
		$of_options[] = array(	"name" => "General Settings",
								"type" => "heading");
								
								$of_options[] = array(	"name" => "Custom Favicon",
														"desc" => "Upload a 16px x 16px PNG/GIF image that will represent your website's favicon.",
														"id" => "site_favicon",
														"type" => "media");
								
								$of_options[] = array(	"name" => "Custom Logo",
														"desc" => "Upload a custom logo for your website.",
														"id" => "site_logo",
														"type" => "media");
								
								$of_options[] = array(	"name" => "Custom Logo Retina @2x",
														"desc" => "Upload a custom logo for retina version. It should be 2x the size of main logo.",
														"id" => "site_logo_retina",
														"type" => "media");
								
								$of_options[] = array(	"name" => "Logo Width for Retina",
														"desc" => "If retina logo is uploaded, please enter the standard logo (1x) version width, do not enter the retina logo width.",
														"id" => "site_logo_width",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Logo Height for Retina",
														"desc" => "If retina logo is uploaded, please enter the standard logo (1x) version height, do not enter the retina logo height.",
														"id" => "site_logo_height",
														"type" => "text");
								
								$of_options[] = array(	"name" => "404 Text",
														"desc" => "Enter your 404 (Page Not Found) Text here.",
														"id" => "site_404",
														"type" => "textarea");
								
								$of_options[] = array(	"name" => "Tracking Code",
														"desc" => "Paste your Google Analytics (or other) tracking code here. This will be added into the footer template of your theme.",
														"id" => "site_tracking",
														"type" => "textarea");
		
		
		//Styling Settings
		$of_options[] = array(	"name" => "Styling Settings",
								"type" => "heading");
								
								$of_options[] = array(	"name" => "Enable Responsive",
														"desc" => "Enable / disable responsive mode.",
														"id" => "style_responsive",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
						
								$of_options[] = array(	"name" => "Layout Style",
														"desc" => "Select the style to use for the layout.",
														"id" => "style_layout",
														"type" => "select",
														"options" => array('wide' => "Full Width", 'boxed' => "Boxed"));
								
								$of_options[] = array(	"name" => "Pre-Defined Skins",
														"desc" => "Select a color scheme for your website.",
														"id" => "style_skin",
														"type" => "images",
														"options" => $style_skins);
														
														//
								
								$of_options[] = array(	"name" => "Custom Color Scheme",
														"desc" => "Please select this option if you want to enable custom color scheme.",
														"id" => "style_custom",
														"std" => 0,
														"on" => "Enable",
														"off" => "Disable",
														"folds" => 1,
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Main Color",
														"desc" => "Specify the main color scheme.",
														"id" => "style_custom_color",
														"fold" => "style_custom",
														"type" => "color");
								
								$of_options[] = array(	"name" => "Font Color ( Heading )",
														"desc" => "Specify the heading h1-h6 font color.",
														"id" => "style_custom_font_color_heading",
														"fold" => "style_custom",
														"type" => "color");
								
								$of_options[] = array(	"name" => "Font Color ( Body Text )",
														"desc" => "Specify the body font color.",
														"id" => "style_custom_font_color_text",
														"fold" => "style_custom",
														"type" => "color");
								
								$of_options[] = array(	"name" => "Link Color ( Heading )",
														"desc" => "Specify the heading link color.",
														"id" => "style_custom_link_color_heading",
														"fold" => "style_custom",
														"type" => "color");
								
								$of_options[] = array(	"name" => "Link Color Hover ( Heading )",
														"desc" => "Specify the heading link hover color.",
														"id" => "style_custom_link_color_heading_hover",
														"fold" => "style_custom",
														"type" => "color");
								
								$of_options[] = array(	"name" => "Link Color ( Body Text )",
														"desc" => "Specify the link color.",
														"id" => "style_custom_link_color_text",
														"fold" => "style_custom",
														"type" => "color");
								
								$of_options[] = array(	"name" => "Link Color Hover ( Body Text )",
														"desc" => "Specify the link hover color.",
														"id" => "style_custom_link_color_text_hover",
														"fold" => "style_custom",
														"type" => "color");
														
														//
						
								$of_options[] = array(	"name" => "Background for Narrow Layout",
														"desc" => "Select the type to use for the background.",
														"id" => "style_bg_type",
														"type" => "select",
														"options" => array(0 => "None", 1 => "Pattern", 2 => "Custom Background"));
								
								$of_options[] = array(	"name" => "Choose Pattern",
														"desc" => "Select a background pattern for your website.",
														"id" => "style_bg_pattern",
														"type" => "images",
														"options" => $style_pattern);
								
								$of_options[] = array(	"name" => "Custom Background",
														"desc" => "Upload a custom background for your Website.",
														"id" => "style_bg_image",
														"type" => "background");
														
														//
								
								$of_options[] = array(	"name" => "Background Title",
														"desc" => "Upload a title background for your Website.",
														"id" => "style_bg_title",
														"type" => "background");
								
								$of_options[] = array(	"name" => "Background Footer",
														"desc" => "Upload a footer background for your Website.",
														"id" => "style_bg_footer",
														"type" => "background");
														
														//
								
								$of_options[] = array(	"name" => "Custom CSS",
														"desc" => "Use this text area if you wish to insert custom CSS into your website.",
														"id" => "style_css",
														"type" => "textarea");
		
		
		//Font Settings
		$of_options[] = array(	"name" => "Font Settings",
								"type" => "heading");
								
					$of_options[] = array(	"type" => "info",
											"std" => "Heading Typography");
								
								$of_options[] = array(	"name" => "Font Type",
														"desc" => "Select the type to use for the fonts.",
														"id" => "style_heading_ft",
														"std" => array("webfont" => true, "google" => true),
														"type" => "font_type");
								
								$of_options[] = array(	"name" => "Font Size",
														"desc" => "Specify the heading font size.",
														"id" => "style_heading_fz",
														"type" => "font_sizeh");
								
					$of_options[] = array(	"type" => "info",
											"std" => "Menu Navigation Typography");
								
								$of_options[] = array(	"name" => "Font Type",
														"desc" => "Select the type to use for the fonts.",
														"id" => "style_menu_ft",
														"std" => array("webfont" => true, "google" => true),
														"type" => "font_type");
								
								$of_options[] = array(	"name" => "Font Size",
														"desc" => "Specify the menu font size.",
														"id" => "style_menu_fz",
														"type" => "font_sizeb");
								
					$of_options[] = array(	"type" => "info",
											"std" => "Body Content Typography");
								
								$of_options[] = array(	"name" => "Font Type",
														"desc" => "Select the type to use for the fonts.",
														"id" => "style_body_ft",
														"std" => array("webfont" => true, "google" => true),
														"type" => "font_type");
								
								$of_options[] = array(	"name" => "Font Size",
														"desc" => "Specify the body font size.",
														"id" => "style_body_fz",
														"type" => "font_sizeb");
		
		
		//Interface Settings
		$of_options[] = array(	"name" => "Interface Settings",
								"type" => "heading");
								
					$of_options[] = array(	"type" => "info",
											"std" => "General Interface");
								
								$of_options[] = array(	"name" => "Call-Us Header",
														"desc" => "Enable / disable phone & email.",
														"id" => "interface_callus",
														"std" => 1,
														"folds"	=> 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Call-Phone Header",
														"desc" => "Enter your phone number here.",
														"id" => "interface_callus_phone",
														"fold" => "interface_callus",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Call-Email Header",
														"desc" => "Enter your email address here.",
														"id" => "interface_callus_email",
														"fold" => "interface_callus",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Social Header",
														"desc" => "Enable / disable social icons.",
														"id" => "interface_social",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "WPML Language Header",
														"desc" => "Enable / disable WPML language.",
														"id" => "interface_lang",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "WooCommerce Cart Header",
														"desc" => "Enable / disable woocommerce cart.",
														"id" => "interface_woo",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Breadcrumb",
														"desc" => "Enable / disable breadcrumb.",
														"id" => "interface_breadcrumb",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Inline Editing",
														"desc" => "Enable / disable inline-editing button to all pages & posts.",
														"id" => "interface_editing",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
					$of_options[] = array(	"type" => "info",
											"std" => "Blog Interface");
								
								$of_options[] = array(	"name" => "Post Excerpt",
														"desc" => "Enable / disable post-excerpt on blog page & blog category.",
														"id" => "interface_excerpt",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Post Meta (Date)",
														"desc" => "Enable / disable date.",
														"id" => "interface_post_date",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Post Meta (Author)",
														"desc" => "Enable / disable author.",
														"id" => "interface_post_author",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Post Meta (Category)",
														"desc" => "Enable / disable category.",
														"id" => "interface_post_category",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Post Meta (Comments)",
														"desc" => "Enable / disable comments.",
														"id" => "interface_post_comments",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Post Tags Cloud",
														"desc" => "Enable / disable tags.",
														"id" => "interface_post_tags",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
					$of_options[] = array(	"type" => "info",
											"std" => "Portfolio Interface");
								
								$of_options[] = array(	"name" => "Portfolio Project Detail",
														"desc" => "Enable / disable all meta.",
														"id" => "interface_portfolio_meta",
														"std" => 1,
														"folds"	=> 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Portfolio Meta (Date)",
														"desc" => "Enable / disable date.",
														"id" => "interface_portfolio_date",
														"std" => 1,
														"fold" => "interface_portfolio_meta",
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Portfolio Meta (Category)",
														"desc" => "Enable / disable category.",
														"id" => "interface_portfolio_category",
														"std" => 1,
														"fold" => "interface_portfolio_meta",
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Portfolio Meta (Client)",
														"desc" => "Enable / disable client.",
														"id" => "interface_portfolio_client",
														"std" => 1,
														"fold" => "interface_portfolio_meta",
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Portfolio Meta (Website)",
														"desc" => "Enable / disable website.",
														"id" => "interface_portfolio_website",
														"std" => 1,
														"fold" => "interface_portfolio_meta",
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
		
		
		//Sidebar Settings
		$of_options[] = array(	"name" => "Sidebar Settings",
								"type" => "heading");
								
								$of_options[] = array(	"name" => "Dinamic Page Sidebar",
														"desc" => "Enter your sidebar text here.",
														"id" => "sidebar",
														"type" => "sidebar");
								
								$of_options[] = array(	"name" => "Archive",
														"desc" => "Select sidebar on 'archive' page.",
														"id" => "sidebar_archive",
														"type" => "select",
														"options" => $sidebar);
								
								$of_options[] = array(	"name" => "Search",
														"desc" => "Select sidebar on 'search' page.",
														"id" => "sidebar_search",
														"type" => "select",
														"options" => $sidebar);
								
								$of_options[] = array(	"name" => "Blog Posts",
														"desc" => "Select sidebar on 'blog posts' page.",
														"id" => "sidebar_single",
														"type" => "select",
														"options" => $sidebar);
		
		
		//Social Settings
		$of_options[] = array(	"name" => "Social Settings",
								"type" => "heading");
								
								$of_options[] = array(	"name" => "Facebook URL",
														"desc" => "Enter the url to your facebook page.",
														"id" => "soc_facebook",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Google+ URL",
														"desc" => "Enter the url to your google+ page.",
														"id" => "soc_google",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Twitter URL",
														"desc" => "Enter the url to your twitter page.",
														"id" => "soc_twitter",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Youtube URL",
														"desc" => "Enter the url to your youtube page.",
														"id" => "soc_youtube",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Flickr URL",
														"desc" => "Enter the url to your flickr page.",
														"id" => "soc_flickr",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Instagram URL",
														"desc" => "Enter the url to your instagram page.",
														"id" => "soc_instagram",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Dribbble URL",
														"desc" => "Enter the url to your dribbble page.",
														"id" => "soc_dribbble",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Linkedin URL",
														"desc" => "Enter the url to your linkedin page.",
														"id" => "soc_linkedin",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Pinterest URL",
														"desc" => "Enter the url to your pinterest page.",
														"id" => "soc_pinterest",
														"type" => "text");
								
								$of_options[] = array(	"name" => "RSS Feed URL",
														"desc" => "If you want to use a service like feedburner enter the feed url here. Otherwise the default wordpress feed url will be used.",
														"id" => "soc_rss",
														"type" => "text");
		
		
		//Contact Settings
		$of_options[] = array(	"name" => "Contact Settings",
								"type" => "heading");
								
								$of_options[] = array(	"name" => "Email Address",
														"desc" => "Please add your e-mail address here.",
														"id" => "contact_email",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Success Message",
														"desc" => "Customize the success message that will be displayed after the user submits the form.",
														"id" => "contact_success",
														"type" => "textarea");
								
								$of_options[] = array(	"name" => "reCAPTCHA",
														"desc" => "Enable / disable reCaptcha.",
														"id" => "contact_recaptcha",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"folds" => 1,
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Public Key",
														"desc" => "Please enter reCaptcha public key.",
														"id" => "contact_publickey",
														"fold" => "contact_recaptcha",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Private Key",
														"desc" => "Please enter reCaptcha private key.",
														"id" => "contact_privatekey",
														"fold" => "contact_recaptcha",
														"type" => "text");
		
		
		//Footer Settings
		$of_options[] = array(	"name" => "Footer Settings",
								"type" => "heading");
								
								$of_options[] = array(	"name" => "Footer Columns",
														"desc" => "Select your footer columns.",
														"id" => "footer_columns",
														"std" => "4",
														"type" => "select",
														"options" => array(	1 => "1 Column", 
																			2 => "2 Columns", 
																			3 => "3 Columns", 
																			4 => "4 Columns"));
								
								$of_options[] = array(	"name" => "Footer Text",
														"desc" => "Enter your footer text here.",
														"id" => "footer_copyright",
														"type" => "textarea");
		
		
		//SEO Settings
		$of_options[] = array(	"name" => "SEO Settings",
								"type" => "heading");
								
								$of_options[] = array(	"name" => "Enable / Disable Theme SEO",
														"desc" => "If you use another SEO plugin, please turn off theme SEO feature.",
														"id" => "seo_enable",
														"std" => 1,
														"on" => "Enable",
														"off" => "Disable",
														"type" => "switch");
								
								$of_options[] = array(	"name" => "Title Separator",
														"desc" => "Default separator ( | )",
														"mod" => "mini",
														"id" => "seo_separator",
														"type" => "text");
								
					$of_options[] = array(	"type" => "info",
											"std" => "Home Page");
								
								$of_options[] = array(	"name" => "Title",
														"desc" => "Enter your homepage title.",
														"id" => "seo_home_title",
														"type" => "text");
								
								$of_options[] = array(	"name" => "Meta Description",
														"desc" => "Enter your site description.",
														"id" => "seo_home_desc",
														"type" => "textarea");
								
								$of_options[] = array(	"name" => "Meta Keywords",
														"desc" => "Enter your site keywords (separate by comma).",
														"id" => "seo_home_key",
														"type" => "textarea");
		
		
		//Advance Settings
		$of_options[] = array(	"name" => "Backup Options",
								"type" => "heading");
								
								$of_options[] = array(	"name" => "Backup and Restore Options",
														"desc" => "You can use the two buttons below to backup your current options, and then restore it back at a later time. This is useful if you want to experiment on the options but would like to keep the old settings in case you need it back.",
														"id" => "backup",
														"type" => "backup");
								
								$of_options[] = array(	"name" => "Transfer Theme Options Data",
														"desc" => "You can tranfer the saved options data between different installs by copying the text inside the text box. To import data from another install, replace the data in the text box with the one from another install and click \"Import Options\".",
														"id" => "transfer",
														"type" => "transfer");
		
		
		//Updates
		$of_options[] = array(	"name" => "Update History",
								"type" => "heading");
								
								$of_options[] = array(	"name" => "Theme Update Notifier",
														"desc" => "",
														"id" => "updated",
														"type" => "updated");
		
				
	}//End function: of_options()
}//End chack if function exists: of_options()
?>
