<?php

/*
Hardcode Options
*/
$st_imgsize = array();
$st_imgsize['page']			= array('w' => 1170,	'h' => 650);
$st_imgsize['blog']			= array('w' => 870,		'h' => 650);
$st_imgsize['work']			= array('w' => 1170,	'h' => 650);
$st_imgsize['work-part']	= array('w' => 870,		'h' => 960);
$st_imgsize['work'][2]		= array('w' => 570,		'h' => 350);
$st_imgsize['work'][3]		= array('w' => 570,		'h' => 350);
$st_imgsize['work'][4]		= array('w' => 570,		'h' => 350);
$st_imgsize['blog-sc']		= array('w' => 570,		'h' => 350);
$st_imgsize['work-sc']		= array('w' => 570,		'h' => 350);

$st_imgsize['team-sc']			= array('w' => 300,		'h' => 300);
$st_imgsize['testimonial-sc']	= array('w' => 140,		'h' => 140);
$st_imgsize['client-sc']		= array('w' => 225,		'h' => 110);


/*
languages
*/
load_theme_textdomain('slicetheme', get_template_directory() . '/lang');
$locale = get_locale();
$locale_file = get_template_directory() . "/lang/$locale.php";
if ( is_readable( $locale_file ) ) {
	require_once( $locale_file );
}


/*
General Function
*/

//
$st_options = of_get_options(); //get_option(OPTIONS);
function st_option($key, $default = '', $echo = FALSE)
{
	global $st_options;
	
	if ( is_array($key) ) {
		foreach ($key as $val) {
			$option[$val] = stripslashes_deep($st_options[$val]);
		}
		return $option;
	}
	
	$option = stripslashes_deep( $st_options[$key] );
	
	if ( empty($option) ) $option = $default;
	
	if ( $echo ) echo $option;
	
	return $option;
}

//
function slicetheme_styles()
{
	global $st_options, $theme_version;
	
	wp_enqueue_style('font', 'http://fonts.googleapis.com/css?family=Open+Sans:300,400,600,700,800');
	wp_enqueue_style('prettyPhoto', SLICETHEME_JS .'/prettyPhoto/prettyPhoto.css', array(), '3.1.5');
	wp_enqueue_style('flexslider', SLICETHEME_JS .'/flexslider/flexslider.css', array(), '2.1');
	wp_enqueue_style('bootstrap', SLICETHEME_CSS .'/bootstrap.min.css', array(), '2.3.1');
	wp_enqueue_style('layout', SLICETHEME_CSS .'/layout.css', array(), $theme_version);	
	
	// Responsive Mode
	$style_responsive = st_option('style_responsive');
	if ( $style_responsive == 1 ) {
		wp_enqueue_style('bootstrap-responsive', SLICETHEME_CSS .'/bootstrap-responsive.min.css', array(), '2.3.1');
		wp_enqueue_style('responsive', SLICETHEME_CSS .'/responsive.css', array(), $theme_version);
	}
	
	// Heading Font	
	$style_heading_ft = st_option('style_heading_ft');
	if ( $style_heading_ft['type'] == 2 ) {
		$style_heading_ft_google = $style_heading_ft['google'];
		$font_name = str_replace(' ', '+', $style_heading_ft_google);
		
		wp_enqueue_style('heading-font', 'http://fonts.googleapis.com/css?family='. $font_name);
	}
	
	// Menu Font
	$style_menu_ft = st_option('style_menu_ft');
	if ( $style_menu_ft['type'] == 2 ) {
		$style_menu_ft_google = $style_menu_ft['google'];
		$font_name = str_replace(' ', '+', $style_menu_ft_google);
		
		wp_enqueue_style('menu-font', 'http://fonts.googleapis.com/css?family='. $font_name);
	}
	
	// Body Font
	$style_body_ft = st_option('style_body_ft');
	if ( $style_body_ft['type'] == 2 ) {
		$style_body_ft_google = $style_body_ft['google'];
		$font_name = str_replace(' ', '+', $style_body_ft_google);
		
		wp_enqueue_style('body-font', 'http://fonts.googleapis.com/css?family='. $font_name);
	}
		
	if ( $style_skin = st_option('style_skin') ) {
		wp_enqueue_style('skin', SLICETHEME_CSS .'/skins/'. $style_skin, array(), $theme_version);
	}
	wp_enqueue_style('custom', SLICETHEME_CSS .'/custom.php', array(), $theme_version);
	wp_enqueue_style('style', get_bloginfo( 'stylesheet_url' ), array(), $theme_version);
}

//
function slicetheme_scripts()
{
	global $st_options;
	
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquery-bootstrap', SLICETHEME_JS .'/bootstrap.min.js', 'jquery', '2.3.1', TRUE);
	wp_enqueue_script('jquery-easing', SLICETHEME_JS .'/jquery.easing.js', 'jquery', '1.3', TRUE);
	wp_enqueue_script('jquery-fitvids', SLICETHEME_JS .'/jquery.fitvids.js', 'jquery', '1.0', TRUE);
	wp_enqueue_script('jquery-viewport', SLICETHEME_JS .'/jquery.viewport.mini.js', 'jquery', '1.0', TRUE);
	wp_enqueue_script('jquery-isotope', SLICETHEME_JS .'/jquery.isotope.min.js', 'jquery', '1.5.25', TRUE);
	
	wp_enqueue_script('jquery-prettyPhoto', SLICETHEME_JS .'/prettyPhoto/jquery.prettyPhoto.js', 'jquery', '3.1.5', TRUE);
	wp_enqueue_script('jquery-flexslider', SLICETHEME_JS .'/flexslider/jquery.flexslider-min.js', 'jquery', '2.1', TRUE);
	
	wp_register_script('jquery-gmap-api', 'http://maps.google.com/maps/api/js?sensor=false', array(), FALSE, TRUE);
	wp_register_script('jquery-gmap', SLICETHEME_JS .'/jquery.gmap.min.js', 'jquery', '3.3.3', TRUE);
	
	if ( is_singular() && comments_open() && get_option('thread_comments') ) {
		wp_enqueue_script( 'comment-reply' ); 
	}
	
	wp_enqueue_script('custom-script', SLICETHEME_JS .'/scripts.js', 'jquery', '1.0', TRUE);
}

add_action('wp_enqueue_scripts', 'slicetheme_styles');
add_action('wp_enqueue_scripts', 'slicetheme_scripts');

//
function slicetheme_wp_title($title)
{	
	global $paged;
	
	$title .= get_option('blogname');
	
	if ( is_front_page() && st_option('seo_home_title') <> '' ) {		
		$title = st_option('seo_home_title');
	}
	
	return $title;
}

function slicetheme_wp_head()
{	
	global $paged;
	
	$head = '';
	
	if ( is_front_page() && $paged <= 1 ) {
		if ( st_option('seo_home_desc') <> '' ) {
			$head .= '<meta name="description" content="'. st_option('seo_home_desc') .'" />'."\n";
		}
		if ( st_option('seo_home_key') <> '' ) {
			$head .= '<meta name="keywords" content="'. st_option('seo_home_key') .'" />'."\n";
		}
	}
	
	echo $head;
}

if ( st_option('seo_enable') == 1 ) {
	add_filter('wp_title', 'slicetheme_wp_title');
	add_action('wp_head', 'slicetheme_wp_head');
}

//
function slicetheme_socials()
{
	$args = array('soc_facebook', 'soc_google', 'soc_twitter', 'soc_youtube', 'soc_flickr', 'soc_instagram', 'soc_dribbble', 'soc_linkedin', 'soc_pinterest');
	
	$socials = st_option($args);
	
	$out = '[social]';
	foreach ($socials as $key => $val) {
		$name = str_replace('soc_', '', $key);
		if ( !empty($val) )
			$out.= '[item type="'. $name .'" url="'. $val .'"]'."\n";
	}
	$out.= '[item type="RSS" url="'. st_option('soc_rss', get_bloginfo('rss2_url')) .'"]'."\n";
	$out.= '[/social]';
	
	echo do_shortcode($out);
}

//
function slicetheme_excerpt($length = 35, $echo = FALSE)
{	
	global $post;
	
	$the_excerpt = strip_shortcodes( $post->post_content );
	$the_excerpt = str_replace(']]>', ']]&gt;', $the_excerpt);
	$the_excerpt = strip_tags($the_excerpt);
	$words = preg_split("/[\n\r\t ]+/", $the_excerpt, $length + 1, PREG_SPLIT_NO_EMPTY);
	if ( count($words) > $length ) {
		array_pop($words);
		$the_excerpt = implode(' ', $words);
		$the_excerpt = $the_excerpt . ' ...';
	} else {
		$the_excerpt = implode(' ', $words);
	}
	
	$the_excerpt = wpautop($the_excerpt);
	
	if ( $echo ) echo $the_excerpt;
	
	return $the_excerpt;
}

//
function slicetheme_resizer($url = '', $width = 150, $height = 150, $cropping = true, $title = '')
{	
	if ( empty($url) ) return;
	
	if ( strstr( $url, site_url() ) ) {
		$image_url = aq_resize( $url, $width, $height, $cropping );
	} else {
		$path = pathinfo($url);
		$new_url = '-'.$width.'x'.$height.'.'.$path['extension'];
		$image_url = str_replace('.'.$path['extension'], $new_url, $url);
		
		if ( !@getimagesize($image_url) ) $image_url = $url;
	}
	
	$out = '<img src="'. $image_url .'" alt="'. $title .'" />';
	
	echo $out;
}

//
function slicetheme_thumbnail($type = '', $full = TRUE)
{	
	global $post;
	
	switch ($type)
	{
		case 'team': 		$thumbnail = 'default-team.png'; break;
		case 'testimonial': $thumbnail = 'default-testimonial.png'; break;
		default: 			$thumbnail = 'default-image.png'; break;
	}
	
	$image_url = get_post_meta(get_the_ID(), '_'.$type.'_image', TRUE);
	if ( trim($image_url) <> '' ) {
		$thumbURL = $image_url;
	}
	else {
		$thumbURL = SLICETHEME_IMAGES .'/'. $thumbnail;
	}
	
	if ( $full ) {
		return '<img src="'. $thumbURL .'" alt="'. get_the_title() .'" />';
	}
	else {
		return $thumbURL;
	}
	
	if ( $post_id == 'nothemecheck' ) the_post_thumbnail();
}

//
function slicetheme_video($video = '')
{
	if ( empty($video) ) return;
	
	$out = '';
	if ( strpos($video,'youtube') ) {
		preg_match('/[\\?\\&]v=([^\\?\\&]+)/', $video, $matches);
		$out.= '<iframe src="http://www.youtube.com/embed/'. $matches[1] .'?version=3&rel=1&fs=1&showsearch=0&showinfo=1&iv_load_policy=1&wmode=transparent" frameborder="0" allowfullscreen></iframe>';
	} else {
		preg_match('/http:\/\/vimeo.com\/(\d+)$/', $video, $matches);
		$out.= '<iframe src="http://player.vimeo.com/video/'. $matches[1] .'?title=0&byline=0&portrait=0" frameborder="0" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>';
	}
	
	echo $out;
}

//
function slicetheme_pagetitle()
{
	/* tax archive */ if (is_tax()) { ?><h1 class="page-title"><?php _e('Archive for category:', 'slicetheme'); ?> <?php single_term_title(); ?></h1>
	<?php
	/* category archive */ } elseif (is_category()) { ?><h1 class="page-title"><?php _e('Archive for category:', 'slicetheme'); ?> <?php single_cat_title(); ?></h1>
	<?php
	/* tag archive */ } elseif( is_tag() ) { ?><h1 class="page-title"><?php _e('Post Tagged with:', 'slicetheme'); ?> &quot;<?php single_tag_title(); ?>&quot;</h1>
	<?php
	/* search archive */ } elseif( is_search() ) { ?><h1 class="page-title"><?php _e('Search Results for:', 'slicetheme'); ?> &quot;<?php echo get_search_query(); ?>&quot;</h1>
	<?php
	/* daily archive */ } elseif (is_day()) { ?><h1 class="page-title"><?php _e('Archive for', 'slicetheme'); ?> <?php the_time('F j, Y'); ?></h1>
	<?php
	/* monthly archive */ } elseif (is_month()) { ?><h1 class="page-title"><?php _e('Archive for', 'slicetheme'); ?> <?php the_time('F, Y'); ?></h1>
	<?php
	/* yearly archive */ } elseif (is_year()) { ?><h1 class="page-title"><?php _e('Archive for', 'slicetheme'); ?> <?php the_time('Y'); ?></h1>
	<?php
	/* author archive */ } elseif (is_author()) { ?><h1 class="page-title"><?php _e('Author Archive', 'slicetheme'); ?></h1>
	<?php
	/* paged archive */ } elseif (isset($_GET['paged']) && !empty($_GET['paged'])) { ?><h1 class="page-title"><?php _e('Archives', 'slicetheme'); ?></h1>
	<?php
	/* 404 page */ } elseif (is_404()) { ?><h1 class="page-title"><?php _e('Page Not Found', 'slicetheme');?></h1><?php } else { echo '&nbsp;'; }
}

//
function slicetheme_breadcrumb()
{ 
	$delimiter = '<span class="divider">/</span>';
	$currentBefore = '<li class="active">';
	$currentAfter = '</li>';
	
	if ( !is_home() && !is_front_page() || is_paged() ) {
		echo '<ul class="breadcrumb visible-desktop">';
	
		global $post;
		$home = home_url();
		echo '<li><a href="'. $home .'"><i class="icon-home"></i></a> '. $delimiter .'</li>'; //__('Home', 'slicetheme')
		
		if ( is_tax() ) {
			  $term = get_term_by( 'slug', get_query_var( 'term' ), get_query_var( 'taxonomy' ) );
			  echo $currentBefore . $term->name . $currentAfter;
	
		} elseif ( is_category() ) {
			global $wp_query;
			$cat_obj = $wp_query->get_queried_object();
			$thisCat = $cat_obj->term_id;
			$thisCat = get_category($thisCat);
			$parentCat = get_category($thisCat->parent);
			if ($thisCat->parent != 0) echo '<li>'. get_category_parents($parentCat, TRUE, ' '. $delimiter .'</li><li>') .'</li>';
			echo $currentBefore;
			single_cat_title();
			echo $currentAfter;
		
		} elseif ( is_day() ) {
			echo '<li><a href="'. get_year_link(get_the_time('Y')) .'">' . get_the_time('Y') . '</a> '. $delimiter .'</li>';
			echo '<li><a href="'. get_month_link(get_the_time('Y'),get_the_time('m')) .'">' . get_the_time('F') . '</a> '. $delimiter .'</li>';
			echo $currentBefore . get_the_time('d') . $currentAfter;
		
		} elseif ( is_month() ) {
			echo '<li><a href="'. get_year_link(get_the_time('Y')) .'">' . get_the_time('Y') . '</a> '. $delimiter .'</li>';
			echo $currentBefore . get_the_time('F') . $currentAfter;
		
		} elseif ( is_year() ) {
			echo $currentBefore . get_the_time('Y') . $currentAfter;
		
		} elseif ( is_single() ) {
			$postType = get_post_type();
			if ( $postType == 'post' ) {
			$cat = get_the_category(); $cat = $cat[0];
			echo '<li>'. get_category_parents($cat, TRUE, ' '. $delimiter .'</li><li>') .'</li>';
			}
			elseif($postType == 'portfolio')
			{
			$terms = get_the_term_list($post->ID, 'portfolio-category', '', '###', '');
			$terms = explode('###', $terms);
			echo '<li>'. $terms[0] .' '. $delimiter .'</li>';
			}
			echo $currentBefore;
			the_title();
			echo $currentAfter;
		
		} elseif ( is_page() && !$post->post_parent ) {
			echo $currentBefore;
			the_title();
			echo $currentAfter;
		
		} elseif ( is_page() && $post->post_parent ) {
			$parent_id  = $post->post_parent;
			$breadcrumbs = array();
			while ($parent_id) {
			$page = get_page($parent_id);
			$breadcrumbs[] = '<li><a href="'. get_permalink($page->ID) .'">' . get_the_title($page->ID) . '</a> '. $delimiter .'</li></li>';
			$parent_id  = $page->post_parent;
			}
			$breadcrumbs = array_reverse($breadcrumbs);
			foreach ($breadcrumbs as $crumb) echo '<li>'. $crumb .'</li>';
			echo $currentBefore;
			the_title();
			echo $currentAfter;
		
		} elseif ( is_search() ) {
			echo $currentBefore . __('Search Results for:', 'slicetheme'). ' &quot;' . get_search_query() . '&quot;' . $currentAfter;
		
		} elseif ( is_tag() ) {
			echo $currentBefore . __('Post Tagged with:', 'slicetheme'). ' &quot;';
			single_tag_title();
			echo '&quot;' . $currentAfter;
		
		} elseif ( is_author() ) {
			global $author;
			$userdata = get_userdata($author);
			echo $currentBefore . __('Author Archive', 'slicetheme') . $currentAfter;
		
		} elseif ( is_404() ) {
			echo $currentBefore . __('Page Not Found', 'slicetheme') . $currentAfter;
		
		}
		
		if ( get_query_var('paged') ) {
		if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ' (';
		echo __(' Page', 'slicetheme') . ' ' . get_query_var('paged');
		if ( is_category() || is_day() || is_month() || is_year() || is_search() || is_tag() || is_author() ) echo ')';
		}
	
		echo '</ul>';
	}
}

//
function slicetheme_comment($comment, $args, $depth)
{
	$GLOBALS['comment'] = $comment;
	?>
	<li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
		<article class="comment" id="comment-<?php comment_ID(); ?>">
			<!--   comment meta   -->
			<header class="comment-meta">
				<!--   comment author   -->
				<div class="comment-author vcard">
					<span class="avatar"><?php echo get_avatar( $comment->comment_author_email, 48 ); ?></span>
					<cite class="fn"><?php echo get_comment_author_link(); ?></cite> <span class="says"><?php _e('says:', 'slicetheme'); ?></span>
					<span class="commentmetadata">
						<a href="<?php echo esc_url( get_comment_link( $comment->comment_ID ) ) ?>"><?php printf(__('%1$s at %2$s', 'slicetheme'), get_comment_date(),  get_comment_time()) ?></a><?php edit_comment_link(__('(Edit)', 'slicetheme'),'  ','') ?>
					</span>
				</div>
				<!--   end comment author   -->
			</header>
			<!--   end comment meta   -->
			<!--   comment content   -->
			<div class="comment-content">
				<?php comment_text() ?>
				<?php comment_reply_link(array_merge( $args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
			</div>
			<!--   end comment content   -->
		</article>
	<?php
}

//
function slicetheme_pagenav($pages = '', $range = 4)
{
     global $wp_query, $paged;
	 
	 $showitems = ($range * 2) + 1; 
     if ( empty($paged) ) $paged = 1;

     if ( $pages == '' ) {
         $pages = $wp_query->max_num_pages;
         if ( !$pages ) {
             $pages = 1;
         }
     }   

     if ( 1 != $pages )
     {
		 echo '<div class="pagination">';
         if ( $paged > 2 && $paged > $range + 1 && $showitems < $pages ) echo ' <a href="'.get_pagenum_link(1).'">&laquo;</a>';
         if ( $paged > 1 && $showitems < $pages ) echo ' <a href="'.get_pagenum_link($paged - 1).'">&lsaquo;</a>';

         for ( $i=1; $i <= $pages; $i++ )
         {
             if ( 1 != $pages && (!($i >= $paged+$range+1 || $i <= $paged-$range-1) || $pages <= $showitems) )
             {
                 echo ( $paged == $i ) ? ' <span class="current">'.$i.'</span>':' <a href="'.get_pagenum_link($i).'" class="inactive" >'.$i.'</a>';
             }
         }

         if ( $paged < $pages && $showitems < $pages ) echo ' <a href="'.get_pagenum_link($paged + 1).'">&rsaquo;</a>';  
         if ( $paged < $pages-1 &&  $paged+$range-1 < $pages && $showitems < $pages ) echo ' <a href="'.get_pagenum_link($pages).'">&raquo;</a>';
         echo '</div>'."\n";
     }
	 
	 echo '<div class="hide">'; posts_nav_link(); echo '</div>';
}

/*
Walker Menu
*/
class Slicetheme_Walker extends Walker_Nav_Menu {
	function start_el(&$output, $item, $depth, $args) {		
		if ( isset($item->classes[0]) ) {
			$icon_class = $item->classes[0]; unset($item->classes[0]);
			$icon_class = !empty( $icon_class ) ? '<i class="'. $icon_class .'" ></i> ': '';
			$item->title = $icon_class . $item->title;
		}
		
		parent::start_el($output, $item, $depth, $args);
	}
    function display_element( $element, &$children_elements, $max_depth, $depth=0, $args, &$output ) {
        $id_field = $this->db_fields['id'];
        if ( !empty( $children_elements[ $element->$id_field ] ) ) {
            $element->classes[] = 'menu-parent-item';
        }
        parent::display_element($element, $children_elements, $max_depth, $depth, $args, $output);
    }
}


/*
WordPress Filter Function
*/

//
function slicetheme_attachment_filter($attachment_link)
{	
	$pattern		= "/<a(.*?)href=('|\")([^>]*).(bmp|gif|jpeg|jpg|png)('|\")(.*?)>(.*?)<\/a>/i";
	$replacement	= '<a$1href=$2$3.$4$5 rel="prettyPhoto[gal_sc]"$6>$7</a>';
	$attachment_link= preg_replace($pattern, $replacement, $attachment_link);
	return $attachment_link;
}
add_filter('wp_get_attachment_link', 'slicetheme_attachment_filter');

//
add_filter( 'use_default_gallery_style', '__return_false' );


/*
LayerSlider
*/
function slicetheme_layerslider_overrides() {

	// Disable auto-updates
	$GLOBALS['lsAutoUpdateBox'] = false;
}
add_action('layerslider_ready', 'slicetheme_layerslider_overrides');


/*
Extended Function
*/
function slicetheme_encrypt($text)
{
	return trim(base64_encode(mcrypt_encrypt(MCRYPT_RIJNDAEL_256, 'b05B7ND1RwpOHIvmA2Vk', $text, MCRYPT_MODE_ECB, mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND))));
}
function slicetheme_decrypt($text)
{
	return trim(mcrypt_decrypt(MCRYPT_RIJNDAEL_256, 'b05B7ND1RwpOHIvmA2Vk', base64_decode($text), MCRYPT_MODE_ECB, mcrypt_create_iv(mcrypt_get_iv_size(MCRYPT_RIJNDAEL_256, MCRYPT_MODE_ECB), MCRYPT_RAND)));
}
