<?php
/**
 * The Template for displaying all single products.
 *
 * Override this template by copying it to yourtheme/woocommerce/single-product.php
 *
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     1.6.4
 */

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

get_header('shop'); ?>

	<?php if ( apply_filters( 'woocommerce_show_page_title', true ) ) : ?>
	
		<?php get_template_part( 'library/header/header-woocommerce' );	?>
	
	<?php endif; ?>	

<!-- main-container -->
<section id="main-wrapper" role="main">

	<div class="container">
	<div class="row-fluid">

	<?php if ( slicetheme_woo_sidebar() == 'lb' ) { ?>
		<!-- sidebar left -->
		<aside id="sidebar-wrapper" class="span3 sidebar">
		
			<?php if (!function_exists('dynamic_sidebar') || !dynamic_sidebar( 'Shop' )) : ?><?php endif; ?>
		
		</aside>
		<!-- end sidebar left -->
	<?php }	?>
	
	<div id="content-wrapper" class="span9 content-part">	
	<?php
		/**
		 * woocommerce_before_main_content hook
		 *
		 * @hooked woocommerce_output_content_wrapper - 10 (outputs opening divs for the content)
		 * @hooked woocommerce_breadcrumb - 20
		 */
		do_action('woocommerce_before_main_content');
	?>

		<?php while ( have_posts() ) : the_post(); ?>

			<?php woocommerce_get_template_part( 'content', 'single-product' ); ?>

		<?php endwhile; // end of the loop. ?>

	<?php
		/**
		 * woocommerce_after_main_content hook
		 *
		 * @hooked woocommerce_output_content_wrapper_end - 10 (outputs closing divs for the content)
		 */
		do_action('woocommerce_after_main_content');
	?>
	</div>

	<?php if ( slicetheme_woo_sidebar() == 'rb' ) { ?>
		<!-- sidebar right -->
		<aside id="sidebar-wrapper" class="span3 sidebar">
		
			<?php if (!function_exists('dynamic_sidebar') || !dynamic_sidebar( 'Shop' )) : ?><?php endif; ?>
		
		</aside>
		<!-- end sidebar right -->
	<?php }	?>

	</div>
	</div>

</section>
<!-- end main-container -->

<?php get_footer('shop'); ?>